class PYF:
	def __init__(this, file):
		this.indent = 0
		this.f = file
		
	def header(this, name):
		this.writeln("from Togra import *")
		this.writeln("from TograUtil import *")
		this.writeln("")
		this.writeln("def %s():" % name)
		this.indent += 1
		this.writeln("%s_C = Container()" % name)
		this.name = name

	def container(this, name):
		this.writeln("%s = Container()" % (name,))
		this.writeln("%s_C.append(%s)" % (this.name, name))

	def vectorList(this, name, list):
		this.writeln("%s = VectorList(%d)" % (name, len(list)))
		this.write("map(lambda a: %s.append(Vector(a[0],a[1],a[2])), " %
			(name,))
		this.writeln("[")
		this.indent += 1
		for i in list[:-1]:
			this.writeln("(%.11f,%.11f,%.11f)," % (i[0],i[1],i[2]))
		i = list[-1]
		this.writeln("(%.11f,%.11f,%.11f)" % (i[0],i[1],i[2]))
		this.indent -= 1
		this.writeln("])")
		
	def intList(this, name, list):
		this.writeln("%s = IntList(%d)" % (name, len(list)))
		this.writeln("map(%s.append, [" % (name,))
		this.indent += 1
		for i in range((len(list)+1)/12):
			s = ""
			for j in range(12):
				try:
					s += "%3d, " % (list[i*12+j],)
				except:
					break
			if i == (len(list)+1)/12 - 1:
				s = s[:-2]
			this.writeln(s)
		this.indent -= 1
		this.writeln("])")
					
	def material(this, name, amb, em, spec, shin):
		this.writeln("%s = Material(" % (name,))
		this.indent += 1
		this.writeln("ambient="+str(amb)+",")
		this.writeln("specular="+str(spec)+",")
		this.writeln("emissive="+str(em)+",")
		this.writeln("shininess="+str(shin))
		this.indent -= 1
		this.writeln(")")
	
	def setMaterial(this, container, material):
		this.writeln("%s.setMaterial(%s)" % (container, material))

	def staticRender(this, name, container, 
				vectors, type, faces, normals = None):
		s = "%s = StaticRender(%s, %s, faces=%s" % \
			(name, vectors, type, faces)
		if not normals is None:
			s += ", normals=%s" % (normals,)
		s += ")"
		this.writeln(s)
		this.writeln("%s.append(%s)" % (container, name))

	def finish(this):
		this.writeln("return %s_C" % (this.name))
		this.indent -= 1

	def write(this, string):
		this.f.write("\t"*this.indent)
		this.f.write(string)

	def writeln(this, string):
		this.write(string)
		this.f.write("\n")

