#define BITS_PER_NODE	1
#define BP1		(1 << BITS_PER_NODE)		
#define PARTITION_ELTS	(BP1*BP1*BP1)

struct _Partition_3D;

typedef struct _Partition_3D {
	void *this_level[PARTITION_ELTS];
	struct _Partition_3D *next_level[PARTITION_ELTS];
} Partition_3D;

typedef int (*partition_3d_foreach_func)(int x, int y, int z, void *data, 
		void *passed_data);

Partition_3D *create_partition_3d(void);
int partition_3d_insert(Partition_3D *p, int x, int y, int z, void *data);
void *partition_3d_retrieve(Partition_3D *p, int x, int y, int z);
void partition_3d_foreach(Partition_3D *p, partition_3d_foreach_func func,
		void *passthrough);
