#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>

#include <stdio.h>

void glVertex3f(float a, float b, float c) {
	printf("\tglVertex3f(%f, %f, %f);\n", a, b, c);
}

void glutPostRedisplay() {
	printf("\tglutPostRedisplay();\n");
}

void glutSwapBuffers() {
	printf("\tglutSwapBuffers();\n");
}

void glCallList(GLuint list) {
	printf("\tglCallList(%d);\n", list);
}

void glScalef(float a, float b, float c) {
	printf("\tglScalef(%f, %f, %f);\n", a, b, c);
}

void glPopMatrix() {
	printf("\tglPopMatrix();\n");
}

void glEnable(GLenum cap) {
	printf("\tglEnable(%d);\n", cap);
}

void glLightfv(GLenum light, GLenum pname, const GLfloat *params)
{
	printf("\t{\n");
	printf("\t\tfloat _i[] = {%f, %f, %f, %f};\n", params[0], params[1], 
			params[2], params[3]);
	printf("\t\tglLightfv(%d, %d, _i);\n", light, pname);
	printf("\t}\n");
}

void glPushMatrix() {
	printf("\tglPushMatrix();\n");
}

void gluLookAt(GLdouble a, GLdouble b, GLdouble c, GLdouble d, GLdouble e,
		GLdouble f, GLdouble g, GLdouble h, GLdouble i) {
	printf("\tgluLookAt(%f,%f,%f,%f,%f,%f,%f,%f,%f);\n", a,b,c,d,e,f,g,h,i);
}

void glLoadIdentity() {
	printf("\tglLoadIdentity();\n");
}

void glMatrixMode(GLenum a) {
	printf("\tglMatrixMode(%d);\n", a);
}

void glClear(GLbitfield mask) {
	printf("\tglClear(0x%x);\n", mask);
}

void glEndList() {
	printf("\tglEndList();\n");
}

void glEnd() {
	printf("\tglEnd();\n");
}

void glNormal3f(float a, float b, float c) {
	printf("\tglNormal3f(%f,%f,%f);\n", a, b, c);
}

void glBegin(GLenum a) {
	printf("\tglBegin(%d);\n", a);
}

void glNewList(GLuint list, GLenum mode) {
	printf("\tglNewList(%d, %d);\n", list, mode);
}

static int i = 0;

GLuint glGenLists(GLsizei range) {
	printf("\tglGenLists(%d);\n", range);
	return ++i;
}

static void (*draw)(void) = NULL;

void glutMainLoop() {
	printf("\tglutMainLoop();\n}\n");
	fflush(stdout);
	printf("void draw(void) {\n");
	draw();
	printf("}\n");
}


void glutDisplayFunc(void (*func)(void)) {
	printf("\tglutDisplayFunc(draw);\n");
	draw = func;
}

void glLightModelfv(GLenum a, const GLfloat *params) {
	printf("\t{\n");
	printf("\t\tfloat _i[] = {%f,%f,%f};\n", params[0], params[1],
			params[2]);
	printf("\t\tglLightModelfv(%d, _i);\n", a);
	printf("\t}\n");
}

void glNormal3dv(const GLdouble *params) {
	printf("\t{\n");
	printf("\t\tdouble _i[] = {%f,%f,%f};\n", params[0], params[1],
			params[2]);
	printf("\t\tglNormal3dv(_i);\n");
	printf("\t}\n");
}

void glVertex3dv(const GLdouble *params) {
	printf("\t{\n");
	printf("\t\tdouble _i[] = {%f,%f,%f};\n", params[0], params[1],
			params[2]);
	printf("\t\tglVertex3dv(_i);\n");
	printf("\t}\n");
}

void glMaterialfv(GLenum face, GLenum pname, const GLfloat *params) {
	printf("\t{\n");
	printf("\t\tfloat _i[] = {%f,%f,%f,%f};\n", params[0], params[1],
			params[2], params[3]);
	printf("\t\tglMaterialfv(%d,%d,_i);\n", face, pname);
	printf("\t}\n");
}

void gluPerspective(GLdouble a, GLdouble b, GLdouble c, GLdouble d) {
	printf("\tgluPerspective(%f,%f,%f,%f);\n", a, b, c, d);
}

void glViewport(GLint a, GLint b, GLsizei c, GLsizei d) {
	printf("\tglViewport(%d, %d, %d ,%d);\n", a, b, c, d);
}

void glPointSize(GLfloat a) {
	printf("\tglPointSize(%f);\n", a);
}

void glColor3f(GLfloat a, GLfloat b, GLfloat c) {
	printf("\tglColor3f(%f, %f, %f);\n", a, b, c);
}

void glClearColor(GLclampf r, GLclampf g, GLclampf b, GLclampf a) {
	printf("\tglClearColor(%f,%f,%f,%f);\n", r, g, b, a);
}

int glutCreateWindow(const char *t)
{
	printf("\tglutCreateWindow(\"%s\");\n", t);
	return 0;
}

void glutInit(int *argcp, char **argv)
{
	printf("#include <GL/gl.h>\n");
	printf("#include <GL/glu.h>\n");
	printf("#include <GL/glut.h>\n\n");
	printf("void draw(void);\n\n");
	printf("int main(int argc, char *argv[]) {\n");
	printf("\tglutInit(&argc, argv);\n");
}

void glutInitDisplayMode(unsigned int mode) {
	printf("\tglutInitDisplayMode(%d);\n", mode);
}

void glutInitWindowSize(int a, int b) {
	printf("\tglutInitWindowSize(%d,%d);\n", a, b);
}

void glutInitWindowPosition(int a, int b) {
	printf("\tglutInitWindowPosition(%d,%d);\n", a, b);
}

void glDrawElements(GLenum mode, GLsizei count, GLenum type,
		const GLvoid *indices)
{
	printf("#error \" I can't support glDrawElements!\"\n");
}

void glMultMatrixd(const GLdouble *m) {
	printf("#error \" I can't support glMultMatrixd!\"\n");
}

void glTexImage2D( GLenum target, GLint level,
                                    GLint internalFormat,
                                    GLsizei width, GLsizei height,
                                    GLint border, GLenum format, GLenum type,
                                    const GLvoid *pixels )
{
	printf("#error \" I can't support glTexImage2d!\"\n");
}

void glGenTextures(GLsizei n, GLuint *textures) {
	printf("#error \"I can't support glGenTextures!\"\n");
}

void glutKeyboardFunc(void (*func)(unsigned char key, int x, int y)) {
	printf("#error \"I can't support glutKeyboardFunc!\"\n");
}

void glDrawArrays(GLenum mode, GLint first, GLsizei count) {
	printf("#error \"I can't support glDrawArrays!\"\n");
}

void glStencilFunc(GLenum func, GLint ref, GLuint mask) {
	printf("\tglStencilFunc(%d, %d, %d);\n", func, ref, mask);
}

void glEnableClientState(GLenum cap) {
	printf("\tglEnableClientState(%d);\n", cap);
}

void glDisable(GLenum cap) {
	printf("\tglDisable(%d);\n", cap);
}

void glColorMask(GLboolean red, GLboolean green, GLboolean blue, GLboolean a)
{
	printf("\tglColorMask(%d, %d, %d, %d);\n", red, green, blue, a);
}

void glScaled(GLdouble a, GLdouble b, GLdouble c) {
	printf("\tglScaled(%f, %f, %f);\n", a, b, c);
}

void glutMotionFunc(void (*func)(int x, int y)) {
	printf("#error \"I can't support glMotionFunc!\"\n");
}

void glStencilMask(GLuint mask) {
	printf("\tglStencilMask(%d);\n", mask);
}

void glTexParameteri(GLenum target, GLenum pname, GLint param) {
	printf("\tglTexParameteri(%d, %d, %d);\n", target, pname, param);
}

void glTexCoord2f(float a, float b)
{
	printf("\tglTexCoord2f(%f, %f);\n", a, b);
}

void glutMouseFunc(void (*func)(int button, int state, int x, int y)) {
	printf("#error \"I can't support glutMouseFunc!\"\n");
}

void glTranslated(double a, double b, double c) {
	printf("\tglTranslated(%f, %f, %f);\n", a, b, c);
}

void glVertexPointer(GLint size, GLenum type, GLsizei stride, const GLvoid *p) {
	printf("#error \"I can't support glVertexPointer!\"\n");
}

void glNormalPointer(GLenum type, GLsizei stride, const GLvoid *p) {
	printf("#error \"I can't support glNormalPointer!\"\n");
}

void glutIdleFunc(void (*func)(void)) {
	printf("\tglutIdleFunc(draw);\n");
	draw = func;
}

void glMaterialf(GLenum face, GLenum pname, GLfloat param) {
	printf("\tglMaterialf(%d, %d, %f);\n", face, pname, param);
}

void glTexEnvf(GLenum target, GLenum pname, GLfloat param) {
	printf("\tglTexEnvf(%d, %d, %f);\n", target, pname, param);
}

void glRotated(double a, double b, double c, double d) {
	printf("\tglRotated(%f, %f, %f, %f);\n", a, b, c, d);
}

void glBindTexture(GLenum target, GLuint texture) {
	printf("\tglBindTexture(%d, %d);\n", target, texture);
}

void glCullFace(GLenum mode) {
	printf("\tglCullFace(%d);\n", mode);
}

void glStencilOp(GLenum fail, GLenum zfail, GLenum zpass) {
	printf("\tglStencilOp(%d, %d, %d);\n", fail, zfail, zpass);
}

void glDisableClientState(GLenum cap) {
	printf("\tglDisableClientState(%d);\n", cap);
}
