#ifndef __GSTTOGRASINK_H__
#define __GSTTOGRASINK_H__

#include <gst/gst.h>

G_BEGIN_DECLS

#define GST_TYPE_TOGRASINK \
  (gst_tograsink_get_type())
#define GST_TOGRASINK(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), GST_TYPE_TOGRASINK, GstTograSink))
#define GST_TOGRASINK_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_CAST((klass), GST_TYPE_TOGRASINK, GstTograSink))
#define GST_IS_TOGRASINK(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), GST_TYPE_TOGRASINK))
#define GST_IS_TOGRASINK_CLASS(obj) \
  (G_TYPE_CHECK_CLASS_TYPE((klass), GST_TYPE_TOGRASINK))

typedef struct
{
	guchar *data;
	GstClockTime time;
	
	gint	width;
	gint	height;
} GstTograSinkBuffer;

typedef struct GstTograSink {
    GstElement base_element;

    GstClock     *clock;
    GstPad       *sink_pad;

    GstClockTime time;
    gdouble      framerate;

    gint         set_width;
    gint         set_height;
    gint         cur_width;
    gint         cur_height;

    GMutex       *out_mutex;
    
    gint         waiting_width;
    gint         waiting_height;
    GstClockTime waiting_time;
    GstBuffer    *waiting_buffer;
    
    GstBuffer    *curout_buffer;
    GstTograSinkBuffer out_buffer;
} GstTograSink;

typedef struct GstTograSinkClass {
	GstElementClass parent_class;
} GstTograSinkClass;

GType gst_tograsink_get_type (void);

GstTograSinkBuffer *gst_tograsink_get_buffer (GstTograSink *tograsink);

G_END_DECLS

#endif /* __GSTTOGRASINK_H__ */
