/*
 * Copyright 2003, Shane Stephens.  
 *
 * This work is protected by the BSD license.  Please see license.txt in the
 * root directory for more information.
 */

#include "TograIncludes.h"
#include "stack.h"

stack_obj *stack_alloc(unsigned int size) {

        stack_obj *stack = malloc(size);
        stack->extent = size;
        stack->curpos = ((char *)stack) + size;
        stack->size = 0;

        return stack;

}

void stack_push(stack_obj *stack, void *data, unsigned int size) {

        unsigned int rounded_size = ((size + 3) / 4) * 4;

	printf("push %x\n", data);
	
        assert(rounded_size + sizeof(int) < stack->extent - stack->size);

        stack->curpos = ((char *)stack->curpos) - rounded_size;
        memcpy(stack->curpos, data, size);
        stack->curpos = ((char *)stack->curpos) - sizeof(int);
        *((unsigned int *)stack->curpos) = size;

        stack->size -= rounded_size + sizeof(int);

}

int stack_pop(stack_obj *stack, void **data) {

        unsigned int size, rounded_size;
      
	
        assert(stack->size > 0);

        size = *((unsigned int *)stack->curpos);

        rounded_size = ((size + 3) / 4) * 4;

        *data = (void *)(((char *)stack->curpos) + sizeof(int));
        stack->curpos = (void *)(((char *)(*data)) + rounded_size);

	printf("pop %x\n", *data);
        
	return size;
        
        
}

int stack_peep(stack_obj *stack, void **data) {

        unsigned int size;
        
        assert(stack->size > 0);

        size = *((unsigned int *)stack->curpos);

        *data = (void *)(((char *)stack->curpos) + sizeof(int));

	printf("peep %x\n", *data);
	
        return size;
        
        
}
