from Togra import *
from TograUtil import *
import Tracker

scene = init()
ode = ODEMixin()


t = Tracker.initTracker(scene)

scene.addMixin(ode)
ode.setGravity(Vector(0, -4, 0))

pauseQuitKeystrokes(scene)

scene.newLight(Vector(0, 0, -50), (0.6, 0.4, 0.4, 1))
scene.newLight(Vector(-50, 0, 0), (0.4, 0.6, 0.4, 1))
scene.newLight(Vector(0, 50, 0), (0.4, 0.4, 0.6, 1))

def ODESphere(density, radius, position, velocity, segs, stacks):
	t = sphere(0, 0, 0, radius, segs, stacks)
	o = ODETransform(ode)
	o.setSphere(density, radius)
	o.setPosition(position)
	o.setVelocity(velocity)
	t.transformContainer.append(o)
	return t

def ODEBox(density, x, y, z, position, velocity):
	u = box(0, 0, 0, x, y, z)
	o = ODETransform(ode)
	o.setBox(density, x, y, z)
	o.setPosition(position)
	o.setVelocity(velocity)
	u.transformContainer.append(o)
	return u


scene.baseContainer.append(ODESphere(1, 2, Vector(0, 10, 0),
	Vector(0, 5, 0), 30, 30))
	
scene.baseContainer.append(ODESphere(100, 3, Vector(0, 10, 10),
	Vector(0, 6, -5), 30, 30))

scene.baseContainer.append(ODEBox(0.1, 10, 5, 1, Vector(-4, 0, 1),
	Vector(0, 9, 0)))

scene.baseContainer.append(ODEBox(1, 3, 4, 1, Vector(-2, -10, 0),
	Vector(0, 10, 0)))

scene.baseContainer.transformContainer.append(t)

scene.run()
