from Togra import *
from TograUtil import *
import Image

GL_QUADS=       0x7
GL_RGB=         0x1907

scene = init()

pauseQuitKeystrokes(scene)

rPath = rotatePath(Vector(0,10,0), 2000) 

rScene = rotatePath(Vector(0,10,0), 10000)

refObject = sphere(0, 0, 0, 8, 30, 30)

refObject.transformContainer.append(rPath)
        
m = Material()
m.setTexture(StaticTexture (Image.open("IMG_1716.JPG").resize((1024,1024)).tostring(), 1024, 1024, GL_RGB))
refObject.setMaterial(m)
refObject.setMaterialCoords()

faceRect = quadFace(-10,-10,-10,10,10,10,10,-10)
outlineRect = Container(1)
outlineRect.append(faceRect)
outlineRect.transformContainer.append(Transform(rotateAxis=Vector(0,1,0), rotateAmount=180))

reflectTs = [
Transform(rotateAxis=Vector(0,1,0), rotateAmount=90, translate=Vector(10,0,0)),
Transform(translate=Vector(0,0,10)),
Transform(rotateAxis=Vector(1,0,0), rotateAmount=-90, translate=Vector(0,10,0)),
Transform(rotateAxis=Vector(1,0,0), rotateAmount=90,translate=Vector(0,-10,0))
]

reflectionTs = [
Transform(translate=Vector(20,0,0), scale=Vector(-1,1,1)),
Transform(translate=Vector(0,0,20), scale=Vector(1,1,-1)),
Transform(translate=Vector(0,20,0), scale=Vector(1,-1,1)),
Transform(translate=Vector(0,-20,0), scale=Vector(1,-1,1))
]


for i in range(len(reflectTs)):
	face = Container(1)
	face.append(faceRect)
	#face.transformContainer.append(reflectTs[i])
	reflection = Reflect(face, reflectTs[i], refObject)
	outline = Container(1)
        outline.append(outlineRect)
        outline.transformContainer.append(reflectTs[i])
	oContainer = Container(1)
	oContainer.append(outline)
	oContainer.transformContainer.append(Transform(scale=Vector(1.1,1.1,1.1)))
	scene.baseContainer.append(oContainer)
	scene.baseContainer.append(reflection)

scene.baseContainer.append(refObject)

border = Container(1)
border.append(box(10, 0, 10.1, 0.1, 20.4, 0.2))
border.append(box(10, 10.1, 0, 0.1, 0.2, 20.4))
border.append(box(10, 0, -10.1, 0.1, 20.4, 0.2))
border.append(box(10, -10.1, 0, 0.1, 0.2, 20.4))
border.setMaterial(Material(ambient=(0.6,0,0,1)))

#scene.baseContainer.append(border)

scene.baseContainer.transformContainer.append(rScene)

scene.view_from = Vector(-15, 0, -30)

scene.run()
