import gst
from Togra import GstTexture

def get_texture_objects(locations, placeholder):
	textures = []
	for location in locations:
		texture = GstTexture(256, 256)
		sink = texture.getSink()

		pipeline = gst.parse_launch("{ gnomevfssrc name=src ! " + 
			"decodebin ! ffmpegcolorspace ! videoscale name=out }")
		out_element = pipeline.get_by_name("out")
		sink_bin = out_element.get_managing_bin();
		sink_bin.add(sink)
		out_element.link(sink)
		src = pipeline.get_by_name("src")
		src.set_property("location", location)
		pipeline.set_state(gst.STATE_PLAYING)
		textures.append(texture)
	return textures

def change_res(texture, res):
	sink = texture.getSink()
	sink.set_property("width", res)
	sink.set_property("height", res)

def change_vol(texture, res):
        pass
