from Togra import *
from TograUtil import *
import math

base = init()

pauseQuitKeystrokes(base)

GL_LINE_LOOP = 2
GL_TRIANGLE_FAN = 6
GL_QUAD_STRIP = 8        

def build_gear(inner, outer, spokes, angle):
        circ = circle(0, 0, inner, 10*spokes)
        circ2 = circle(0, 0, outer, 8*spokes)
        ang = - angle * math.pi / 180
        circ2.transform([[math.cos(ang) ,-math.sin(ang), 0],
                         [math.sin(ang),  math.cos(ang), 0],
                         [0, 0, 1]], Vector(0,0,0))

        circ3 = zip(circ, circ2, 2, 8, 3, 5)
        circ4 = extrude(circ3, Vector(0, 0,  5))        
        myRender2 = StaticRender(circ4, GL_QUAD_STRIP, normalMode=1, 
                                genNormals=1)

        circ5 = circle(0, 0, inner/2, 5 * spokes)
        circ6 = extrude(circ5, Vector(0, 0, -5))
        myRender3 = StaticRender(circ6, GL_QUAD_STRIP, normalMode=1,
                                genNormals=1)
        inner_part = Container(2)
        inner_part.append(myRender3)
        inner_part.transformContainer.append(Transform(translate=Vector(0,0,5)))

        circ7 = circle(0, 0, inner/2, 5 * spokes)
        c3r = circ3.reverse()
        ct = circ7.reverse()
        circ8 = zip(c3r, ct)
        circ8.append(circ8[0])
        circ8.append(circ8[1])
        myRender4 = StaticRender(circ8, GL_QUAD_STRIP, normalMode=1,
                                genNormals=1)
      
        circ9 = zip(circ3, circ7)
        circ9.append(circ9[0])
        circ9.append(circ9[1])
        myRender5 = StaticRender(circ9, GL_QUAD_STRIP, normalMode=1,
                                genNormals=1)

        inner_part.append(myRender5)
     
        c = Container(1)
        c.append(myRender2)
        c.append(inner_part)
        c.append(myRender4)
      
        #circ3.append(circ3[0])
        #circ3.insert(0, Vector(0,0,0))
        #c.append(StaticRender(circ3, GL_TRIANGLE_FAN))

        return c

i = rotatePath(Vector(0,1,0), 4000)
i2 = rotatePath(Vector(0,0,1), 2500)
i3 = rotatePath(Vector(1,0.5,0.2), 6500)
i4 = rotatePath(Vector(0,0.5,1), 60000)
i5 = rotatePath(Vector(0,-0.5,-1), 60100)

"""
i2 = InterpolatedPath(3)
i2.setType(2)
i2.append((Vector(0,0,1), 0), 0)
i2.append((Vector(0,0,1), 360), 2500)
i2.setMaxIndex(2500)

i3 = InterpolatedPath(3)
i3.setType(2)
i3.append((Vector(1,0.5,0.2), 0), 0)
i3.append((Vector(1,0.5,0.2), 360), 6500)
i3.setMaxIndex(6500)

i4 = InterpolatedPath(3)
i4.setType(2)
i4.append((Vector(1,0.5,0.2), 0), 0)
i4.append((Vector(0,0.5,1), 360), 60000)
i4.setMaxIndex(60000)
"""

e = Container(1)
e.transformContainer.append(i3)

c = build_gear(10, 15, 20, 9)
c.transformContainer.append(Transform(rotateAxis=Vector(1,0,0), rotateAmount=90))
c.transformContainer.append(i)
c.setMaterial(Material(ambient=(0.5,0,0,1)))
e.append(c)

c = build_gear(5, 8, 30, 9)
c.transformContainer.append(Transform(translate=Vector(0,5,0),rotateAxis=Vector(1,0,0), rotateAmount=90))
c.transformContainer.append(i)
c.setMaterial(Material(ambient=(0,0.5,0,0)))
e.append(c)
c.append(Light(diffuse=(0.3,0.3,0.3,1), location=Vector(0,0,-10)))

c = build_gear(5, 9, 7, 9)
c.transformContainer.append(i2)
c.setMaterial(Material(ambient=(0.1,0.1,0.5,0)))
c.transformContainer.append(Transform(translate=Vector(15,10,0),rotateAxis=Vector(0,1,0), rotateAmount=90))

e.append(c)

base.baseContainer.append(e)
base.baseContainer.transformContainer.append(i4)

base.view_from = Vector(0, 0, -50)

t = TransformContainer()
t.append(i5)

base.newLight(Vector(0,30,0), (0.3,1,1,1), t)
base.setBackgroundColour(0,0,0)

base.run()
